diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/tgax-voip-traffic.h ns-3.47/src/applications/model/tgax-voip-traffic.h
--- ns-3.46/src/applications/model/tgax-voip-traffic.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/tgax-voip-traffic.h	2026-02-16 16:08:49.571229700 -0800
@@ -0,0 +1,196 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef TGAX_VOIP_TRAFFIC_H
+#define TGAX_VOIP_TRAFFIC_H
+
+#include "source-application.h"
+
+#include "ns3/event-id.h"
+#include "ns3/ptr.h"
+#include "ns3/traced-callback.h"
+
+#include <map>
+
+namespace ns3
+{
+
+class ExponentialRandomVariable;
+class UniformRandomVariable;
+class LaplacianRandomVariable;
+
+/**
+ * @ingroup applications
+ * @brief Generate VoIP traffic.
+ *
+ * This voip traffic generator follows requirements from IEEE 802.11-14/0571r12 - 11ax Evaluation
+ * Methodology (see applications documentation for full citation).
+ *
+ * The VoIP traffic alternates between periods of active talking and silence,
+ * with given probabilities to transition from one state to another.
+ * These state updates are assumed to be done at the speech encoder frame rate.
+ *
+ * Fixed-size VoIP packets are generated at every encoder frame interval,
+ * plus a random network packet arrival delay jitter (if BoundDelayJitter is non-zero).
+ * The size of these packets also depend on the current state.
+ *
+ * The VoIP model from the reference relies on UDP with compressed protocol headers.
+ * Since compressed protocol headers are not supported in the simulator, a packet socket
+ * is used instead, allowing user to tune payload sizes by adding up the size of the compressed
+ * headers.
+ *
+ * This model can also be used with usual UDP or TCP sockets. For the later, user should be warned
+ * that the model does not provide any mechanism when TX buffer is full.
+ */
+class TgaxVoipTraffic : public SourceApplication
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    TgaxVoipTraffic();
+    ~TgaxVoipTraffic() override;
+
+    /**
+     * Voice activity states
+     */
+    enum class VoiceActivityState : uint8_t
+    {
+        INACTIVE_SILENCE = 0, //< Inactive/silence state
+        ACTIVE_TALKING = 1,   //< Active/talking state
+    };
+
+    int64_t AssignStreams(int64_t stream) override;
+
+  protected:
+    void DoInitialize() override;
+
+  private:
+    void DoStartApplication() override;
+    void DoConnectionSucceeded(Ptr<Socket> socket) override;
+    void CancelEvents() override;
+
+    /**
+     * Set the mean of the exponential distribution used to calculate durations of active/talking
+     * state
+     * @param mean the mean value
+     */
+    void SetActiveExponentialMean(Time mean);
+
+    /**
+     * Set the mean of the exponential distribution used to calculate durations of inactive/silent
+     * state
+     * @param mean the mean value
+     */
+    void SetInactiveExponentialMean(Time mean);
+
+    /**
+     * Update voice activity state
+     */
+    void UpdateState();
+
+    /**
+     * Schedule the next state update
+     */
+    void ScheduleNext();
+
+    /**
+     * Transmit one VoIP packet
+     * @param eventId the event ID
+     * @param packet the packet to transmit
+     * @param jitter the delay jitter applied to that packet
+     */
+    void SendPacket(uint64_t eventId, Ptr<Packet> packet, Time jitter);
+
+    /**
+     * Get the duration to encode a frame based on the current state
+     *
+     * @return the duration to encode a frame
+     */
+    Time GetEncoderFrameDuration() const;
+
+    /**
+     * Get the interval between two state updates
+     *
+     * @return the interval between two state updates
+     */
+    Time GetStateUpdateInterval() const;
+
+    uint32_t m_activePacketSize;  //!< Size in bytes for payload of active packets
+    uint32_t m_silencePacketSize; //!< Size in bytes for payload of silence packets
+    Time m_voiceInterval;         //!< Interval between generation of voice packets
+    Time m_silenceInterval;       //!< Interval between generation of silence packets
+    double m_activeToInactive;    //!< Probability to transition from active/talking state to
+                                  //!< inactive/silence state
+    double m_inactiveToActive;    //!< Probability to transition from inactive/silence state to
+                                  //!< active/talking state
+    Time m_delayJitterScale; //!< Scale of laplacian distribution used to calculate delay jitter
+    Time m_delayJitterBound; //!< Bound of laplacian distribution used to calculate delay jitter
+
+    Ptr<ExponentialRandomVariable>
+        m_inactiveExponential; //!< Exponential random variable to generate inactive/silent state
+                               //!< durations
+    Ptr<ExponentialRandomVariable> m_activeExponential; //!< Exponential random variable to generate
+                                                        //!< active/talking state durations
+    Ptr<UniformRandomVariable> m_inactiveUniform; //!< Uniform random variable to generate state
+                                                  //!< transitions from inactive state
+    Ptr<UniformRandomVariable> m_activeUniform;   //!< Uniform random variable to generate state
+                                                  //!< transitions from active state
+    Ptr<LaplacianRandomVariable>
+        m_delayJitterLaplacian; //!< Laplacian random variable to generate delay jitter
+
+    VoiceActivityState m_currentState{
+        VoiceActivityState::INACTIVE_SILENCE}; //!< Hold the current voice activity state
+    bool m_pendingStateTransition{false}; //!< Flag whether a state transition should once duration
+                                          //!< of current state has elapsed
+    Time m_remainingStateDuration;        //!< The remaining duration in the current state
+    Time m_remainingEncodingDuration;     //!< The remaining duration to encode the current frame
+
+    EventId m_stateUpdateEvent; //!< Event ID of pending state update event scheduling
+
+    std::map<uint64_t, EventId> m_txPacketEvents; //!< Event IDs of pending TX events
+    uint64_t m_nextEventId{0};                    //!< The next event ID
+
+    /**
+     * TracedCallback signature for packet and jitter.
+     *
+     * @param [in] packet The packet.
+     * @param [in] jitter The networking jitter.
+     */
+    typedef void (*TxTracedCallback)(Ptr<const Packet> packet, Time jitter);
+
+    /**
+     * TracedCallback signature for state change.
+     *
+     * @param [in] state The new state.
+     * @param [in] duration The duration of the state.
+     */
+    typedef void (*StateUpdatedCallback)(VoiceActivityState state, Time duration);
+
+    /// Traced Callback: transmitted packets and their jitters.
+    TracedCallback<Ptr<const Packet>, Time> m_txJitterTrace;
+
+    /// Traced Callback: voice activity state updated.
+    TracedCallback<VoiceActivityState, Time> m_stateUpdate;
+};
+
+/**
+ * Serialize voice activity state to ostream in a human-readable form.
+ *
+ * @param os std::ostream
+ * @param state the voice activity state
+ * @return std::ostream
+ */
+std::ostream& operator<<(std::ostream& os, TgaxVoipTraffic::VoiceActivityState state);
+
+} // namespace ns3
+
+#endif /* TGAX_VOIP_TRAFFIC_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-client.cc ns-3.47/src/applications/model/three-gpp-http-client.cc
--- ns-3.46/src/applications/model/three-gpp-http-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-client.cc	2026-02-16 16:08:49.571229700 -0800
@@ -30,19 +30,11 @@
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppHttpClient);
 
 ThreeGppHttpClient::ThreeGppHttpClient()
-    : m_state{NOT_STARTED},
-      m_socket{nullptr},
-      m_objectBytesToBeReceived{0},
-      m_objectClientTs{},
-      m_objectServerTs{},
-      m_embeddedObjectsToBeRequested{0},
-      m_pageLoadStartTs{},
-      m_numberEmbeddedObjectsRequested{0},
-      m_numberBytesPage{0},
-      m_httpVariables{CreateObject<ThreeGppHttpVariables>()},
-      m_peerPort{}
+    : SourceApplication(false),
+      m_httpVariables{CreateObject<ThreeGppHttpVariables>()}
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::TcpSocketFactory");
 }
 
 // static
@@ -88,10 +80,6 @@
                             "Connection to the destination web server is closed.",
                             MakeTraceSourceAccessor(&ThreeGppHttpClient::m_connectionClosedTrace),
                             "ns3::ThreeGppHttpClient::TracedCallback")
-            .AddTraceSource("Tx",
-                            "General trace for sending a packet of any kind.",
-                            MakeTraceSourceAccessor(&ThreeGppHttpClient::m_txTrace),
-                            "ns3::Packet::TracedCallback")
             .AddTraceSource(
                 "TxMainObjectRequest",
                 "Sent a request for a main object.",
@@ -169,12 +157,6 @@
     }
 }
 
-Ptr<Socket>
-ThreeGppHttpClient::GetSocket() const
-{
-    return m_socket;
-}
-
 ThreeGppHttpClient::State_t
 ThreeGppHttpClient::GetState() const
 {
@@ -220,14 +202,15 @@
 
     if (!Simulator::IsFinished())
     {
-        StopApplication();
+        CancelEvents();
+        CloseSocket();
     }
 
-    Application::DoDispose(); // Chain up.
+    SourceApplication::DoDispose(); // Chain up.
 }
 
 void
-ThreeGppHttpClient::StartApplication()
+ThreeGppHttpClient::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
 
@@ -243,20 +226,14 @@
 }
 
 void
-ThreeGppHttpClient::StopApplication()
+ThreeGppHttpClient::DoStopApplication()
 {
     NS_LOG_FUNCTION(this);
-
     SwitchToState(STOPPED);
-    CancelAllPendingEvents();
-    m_socket->Close();
-    m_socket->SetConnectCallback(MakeNullCallback<void, Ptr<Socket>>(),
-                                 MakeNullCallback<void, Ptr<Socket>>());
-    m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
 }
 
 void
-ThreeGppHttpClient::ConnectionSucceededCallback(Ptr<Socket> socket)
+ThreeGppHttpClient::DoConnectionSucceeded(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
 
@@ -273,7 +250,7 @@
 }
 
 void
-ThreeGppHttpClient::ConnectionFailedCallback(Ptr<Socket> socket)
+ThreeGppHttpClient::DoConnectionFailed(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
 
@@ -292,7 +269,7 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    CancelAllPendingEvents();
+    CancelEvents();
 
     if (socket->GetErrno() != Socket::ERROR_NOTERROR)
     {
@@ -311,7 +288,7 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    CancelAllPendingEvents();
+    CancelEvents();
     if (socket->GetErrno() != Socket::ERROR_NOTERROR)
     {
         NS_LOG_ERROR(this << " Connection has been terminated,"
@@ -380,57 +357,8 @@
         NS_FATAL_ERROR("Invalid state " << GetStateString() << " for OpenConnection().");
     }
 
-    m_socket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
-    NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
-    if (!m_local.IsInvalid())
-    {
-        NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
-                         InetSocketAddress::IsMatchingType(m_local)) ||
-                            (InetSocketAddress::IsMatchingType(m_peer) &&
-                             Inet6SocketAddress::IsMatchingType(m_local)),
-                        "Incompatible peer and local address IP version");
-    }
-    if (InetSocketAddress::IsMatchingType(m_peer))
-    {
-        const auto ret [[maybe_unused]] =
-            m_local.IsInvalid() ? m_socket->Bind() : m_socket->Bind(m_local);
-        NS_LOG_DEBUG(this << " Bind() return value= " << ret
-                          << " GetErrNo= " << m_socket->GetErrno() << ".");
-
-        const auto ipv4 = InetSocketAddress::ConvertFrom(m_peer).GetIpv4();
-        const auto port = InetSocketAddress::ConvertFrom(m_peer).GetPort();
-        NS_LOG_INFO(this << " Connecting to " << ipv4 << " port " << port << " / " << m_peer
-                         << ".");
-        m_socket->SetIpTos(m_tos);
-    }
-    else if (Inet6SocketAddress::IsMatchingType(m_peer))
-    {
-        const auto ret [[maybe_unused]] =
-            m_local.IsInvalid() ? m_socket->Bind6() : m_socket->Bind(m_local);
-        NS_LOG_DEBUG(this << " Bind6() return value= " << ret
-                          << " GetErrNo= " << m_socket->GetErrno() << ".");
-
-        const auto ipv6 = Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6();
-        const auto port = Inet6SocketAddress::ConvertFrom(m_peer).GetPort();
-        NS_LOG_INFO(this << " Connecting to " << ipv6 << " port " << port << " / " << m_peer
-                         << ".");
-    }
-    else
-    {
-        NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
-    }
-
-    const auto ret [[maybe_unused]] = m_socket->Connect(m_peer);
-    NS_LOG_DEBUG(this << " Connect() return value= " << ret << " GetErrNo= " << m_socket->GetErrno()
-                      << ".");
-
-    NS_ASSERT_MSG(m_socket, "Failed creating socket.");
-
     SwitchToState(CONNECTING);
 
-    m_socket->SetConnectCallback(
-        MakeCallback(&ThreeGppHttpClient::ConnectionSucceededCallback, this),
-        MakeCallback(&ThreeGppHttpClient::ConnectionFailedCallback, this));
     m_socket->SetCloseCallbacks(MakeCallback(&ThreeGppHttpClient::NormalCloseCallback, this),
                                 MakeCallback(&ThreeGppHttpClient::ErrorCloseCallback, this));
     m_socket->SetRecvCallback(MakeCallback(&ThreeGppHttpClient::ReceivedDataCallback, this));
@@ -772,7 +700,7 @@
 }
 
 void
-ThreeGppHttpClient::CancelAllPendingEvents()
+ThreeGppHttpClient::CancelEvents()
 {
     NS_LOG_FUNCTION(this);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-client.h ns-3.47/src/applications/model/three-gpp-http-client.h
--- ns-3.46/src/applications/model/three-gpp-http-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-client.h	2026-02-16 16:08:49.571229700 -0800
@@ -21,7 +21,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 class ThreeGppHttpVariables;
 
@@ -113,12 +112,6 @@
      */
     static TypeId GetTypeId();
 
-    /**
-     * Returns a pointer to the associated socket.
-     * @return Pointer to the associated socket.
-     */
-    Ptr<Socket> GetSocket() const;
-
     /// The possible states of the application.
     enum State_t
     {
@@ -183,8 +176,11 @@
     void DoDispose() override;
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void DoStopApplication() override;
+    void DoConnectionSucceeded(Ptr<Socket> socket) override;
+    void DoConnectionFailed(Ptr<Socket> socket) override;
+    void CancelEvents() override;
 
     /**
      * @brief set the remote port (temporary function until deprecated attributes are removed)
@@ -193,19 +189,6 @@
     void SetPort(uint16_t port);
 
     // SOCKET CALLBACK METHODS
-
-    /**
-     * Invoked when a connection is established successfully on #m_socket. This
-     * triggers a request for a main object.
-     * @param socket Pointer to the socket where the event originates from.
-     */
-    void ConnectionSucceededCallback(Ptr<Socket> socket);
-    /**
-     * Invoked when #m_socket cannot establish a connection with the web server.
-     * Simulation will stop and error will be raised.
-     * @param socket Pointer to the socket where the event originates from.
-     */
-    void ConnectionFailedCallback(Ptr<Socket> socket);
     /**
      * Invoked when connection between #m_socket and the web sever is terminated.
      * Error will be logged, but simulation continues.
@@ -341,12 +324,6 @@
      * The method is invoked after a complete web page has been received.
      */
     void EnterReadingTime();
-    /**
-     * Cancels #m_eventRequestMainObject, #m_eventRequestEmbeddedObject, and
-     * #m_eventParseMainObject. Invoked by StopApplication() and when connection
-     * has been terminated.
-     */
-    void CancelAllPendingEvents();
 
     /**
      * Change the state of the client. Fires the `StateTransition` trace source.
@@ -361,11 +338,9 @@
     void FinishReceivingPage();
 
     /// The current state of the client application. Begins with NOT_STARTED.
-    State_t m_state;
-    /// The socket for sending and receiving packets to/from the web server.
-    Ptr<Socket> m_socket;
+    State_t m_state{NOT_STARTED};
     /// According to the content length specified by the ThreeGppHttpHeader.
-    uint32_t m_objectBytesToBeReceived;
+    uint32_t m_objectBytesToBeReceived{0};
     /// The packet constructed of one or more parts with ThreeGppHttpHeader.
     Ptr<Packet> m_constructedPacket;
     /// The client time stamp of the ThreeGppHttpHeader from the last received packet.
@@ -373,13 +348,13 @@
     /// The server time stamp of the ThreeGppHttpHeader from the last received packet.
     Time m_objectServerTs;
     /// Determined after parsing the main object.
-    uint32_t m_embeddedObjectsToBeRequested;
+    uint32_t m_embeddedObjectsToBeRequested{0};
     /// The time stamp when the page started loading.
     Time m_pageLoadStartTs;
     /// Number of embedded objects to requested in the current page.
-    uint32_t m_numberEmbeddedObjectsRequested;
+    uint32_t m_numberEmbeddedObjectsRequested{0};
     /// Number of bytes received for the current page.
-    uint32_t m_numberBytesPage;
+    uint32_t m_numberBytesPage{0};
 
     // ATTRIBUTES
 
@@ -397,8 +372,6 @@
     ns3::TracedCallback<Ptr<const ThreeGppHttpClient>> m_connectionEstablishedTrace;
     /// The `ConnectionClosed` trace source.
     ns3::TracedCallback<Ptr<const ThreeGppHttpClient>> m_connectionClosedTrace;
-    /// The `Tx` trace source.
-    ns3::TracedCallback<Ptr<const Packet>> m_txTrace;
     /// The `TxMainObjectRequest` trace source.
     ns3::TracedCallback<Ptr<const Packet>> m_txMainObjectRequestTrace;
     /// The `TxEmbeddedObjectRequest` trace source.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-header.cc ns-3.47/src/applications/model/three-gpp-http-header.cc
--- ns-3.46/src/applications/model/three-gpp-http-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-header.cc	2026-02-16 16:08:49.571229700 -0800
@@ -22,11 +22,7 @@
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppHttpHeader);
 
 ThreeGppHttpHeader::ThreeGppHttpHeader()
-    : Header(),
-      m_contentType(NOT_SET),
-      m_contentLength(0),
-      m_clientTs(0),
-      m_serverTs(0)
+    : Header()
 {
     NS_LOG_FUNCTION(this);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-header.h ns-3.47/src/applications/model/three-gpp-http-header.h
--- ns-3.46/src/applications/model/three-gpp-http-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-header.h	2026-02-16 16:08:49.571229700 -0800
@@ -115,10 +115,10 @@
     Time GetServerTs() const;
 
   private:
-    uint16_t m_contentType;   //!<" Content type field in integer format.
-    uint32_t m_contentLength; //!<" Content length field (in bytes unit).
-    uint64_t m_clientTs;      //!<" Client time stamp field (in time step unit).
-    uint64_t m_serverTs;      //!<" Server time stamp field (in time step unit).
+    uint16_t m_contentType{0};   //!< Content type field in integer format.
+    uint32_t m_contentLength{0}; //!< Content length field (in bytes unit).
+    uint64_t m_clientTs{0};      //!< Client time stamp field (in time step unit).
+    uint64_t m_serverTs{0};      //!< Server time stamp field (in time step unit).
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-server.cc ns-3.47/src/applications/model/three-gpp-http-server.cc
--- ns-3.46/src/applications/model/three-gpp-http-server.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-server.cc	2026-02-16 16:08:49.571229700 -0800
@@ -34,15 +34,13 @@
 
 ThreeGppHttpServer::ThreeGppHttpServer()
     : SinkApplication(HTTP_DEFAULT_PORT),
-      m_state{NOT_STARTED},
-      m_initialSocket{nullptr},
       m_txBuffer{Create<ThreeGppHttpServerTxBuffer>()},
       m_httpVariables{CreateObject<ThreeGppHttpVariables>()},
-      m_optPort{},
       m_mtuSize{m_httpVariables->GetMtuSize()}
 {
     NS_LOG_FUNCTION(this);
     NS_LOG_INFO(this << " MTU size for this server application is " << m_mtuSize << " bytes.");
+    m_protocolTid = TypeId::LookupByName("ns3::TcpSocketFactory");
 }
 
 // static
@@ -109,10 +107,6 @@
                             "A packet has been sent.",
                             MakeTraceSourceAccessor(&ThreeGppHttpServer::m_txTrace),
                             "ns3::Packet::TracedCallback")
-            .AddTraceSource("Rx",
-                            "A packet has been received.",
-                            MakeTraceSourceAccessor(&ThreeGppHttpServer::m_rxTrace),
-                            "ns3::Packet::AddressTracedCallback")
             .AddTraceSource("RxWithAddresses",
                             "A packet has been received.",
                             MakeTraceSourceAccessor(&ThreeGppHttpServer::m_rxTraceWithAddresses),
@@ -172,7 +166,7 @@
 Ptr<Socket>
 ThreeGppHttpServer::GetSocket() const
 {
-    return m_initialSocket;
+    return m_socket;
 }
 
 ThreeGppHttpServer::State_t
@@ -212,14 +206,14 @@
 
     if (!Simulator::IsFinished())
     {
-        StopApplication();
+        CloseAllSockets();
     }
 
-    Application::DoDispose(); // Chain up.
+    SinkApplication::DoDispose(); // Chain up.
 }
 
 void
-ThreeGppHttpServer::StartApplication()
+ThreeGppHttpServer::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
 
@@ -229,68 +223,50 @@
     }
 
     m_httpVariables->Initialize();
-    if (!m_initialSocket)
+
+    m_socket->SetAttribute("SegmentSize", UintegerValue(m_mtuSize));
+
+    NS_ABORT_MSG_IF(m_local.IsInvalid(), "Local address not properly set");
+    if (InetSocketAddress::IsMatchingType(m_local))
     {
-        // Find the current default MTU value of TCP sockets.
-        Ptr<const ns3::AttributeValue> previousSocketMtu;
-        const TypeId tcpSocketTid = TcpSocket::GetTypeId();
-        for (uint32_t i = 0; i < tcpSocketTid.GetAttributeN(); i++)
-        {
-            TypeId::AttributeInformation attrInfo = tcpSocketTid.GetAttribute(i);
-            if (attrInfo.name == "SegmentSize")
-            {
-                previousSocketMtu = attrInfo.initialValue;
-            }
-        }
+        const auto ipv4 [[maybe_unused]] = InetSocketAddress::ConvertFrom(m_local).GetIpv4();
+        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << m_local
+                         << ".");
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_local))
+    {
+        const auto ipv6 [[maybe_unused]] = Inet6SocketAddress::ConvertFrom(m_local).GetIpv6();
+        NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << m_local
+                         << ".");
+    }
+    else
+    {
+        NS_ABORT_MSG("Incompatible local address");
+    }
 
-        // Creating a TCP socket to connect to the server.
-        m_initialSocket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
-        m_initialSocket->SetAttribute("SegmentSize", UintegerValue(m_mtuSize));
+    auto ret [[maybe_unused]] = m_socket->Bind(m_local);
+    NS_LOG_DEBUG(this << " Bind() return value= " << ret << " GetErrNo= " << m_socket->GetErrno()
+                      << ".");
 
-        NS_ABORT_MSG_IF(m_local.IsInvalid(), "Local address not properly set");
-        if (InetSocketAddress::IsMatchingType(m_local))
-        {
-            const auto ipv4 [[maybe_unused]] = InetSocketAddress::ConvertFrom(m_local).GetIpv4();
-            m_initialSocket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-            NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << m_local
-                             << ".");
-        }
-        else if (Inet6SocketAddress::IsMatchingType(m_local))
-        {
-            const auto ipv6 [[maybe_unused]] = Inet6SocketAddress::ConvertFrom(m_local).GetIpv6();
-            NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << m_local
-                             << ".");
-        }
-        else
-        {
-            NS_ABORT_MSG("Incompatible local address");
-        }
+    ret = m_socket->Listen();
+    NS_LOG_DEBUG(this << " Listen () return value= " << ret << " GetErrNo= " << m_socket->GetErrno()
+                      << ".");
 
-        auto ret [[maybe_unused]] = m_initialSocket->Bind(m_local);
-        NS_LOG_DEBUG(this << " Bind() return value= " << ret
-                          << " GetErrNo= " << m_initialSocket->GetErrno() << ".");
-
-        ret = m_initialSocket->Listen();
-        NS_LOG_DEBUG(this << " Listen () return value= " << ret
-                          << " GetErrNo= " << m_initialSocket->GetErrno() << ".");
-
-        NS_ASSERT_MSG(m_initialSocket, "Failed creating socket.");
-        m_initialSocket->SetAcceptCallback(
-            MakeCallback(&ThreeGppHttpServer::ConnectionRequestCallback, this),
-            MakeCallback(&ThreeGppHttpServer::NewConnectionCreatedCallback, this));
-        m_initialSocket->SetCloseCallbacks(
-            MakeCallback(&ThreeGppHttpServer::NormalCloseCallback, this),
-            MakeCallback(&ThreeGppHttpServer::ErrorCloseCallback, this));
-        m_initialSocket->SetRecvCallback(
-            MakeCallback(&ThreeGppHttpServer::ReceivedDataCallback, this));
-        m_initialSocket->SetSendCallback(MakeCallback(&ThreeGppHttpServer::SendCallback, this));
-    }
+    NS_ASSERT_MSG(m_socket, "Failed creating socket.");
+    m_socket->SetAcceptCallback(
+        MakeCallback(&ThreeGppHttpServer::ConnectionRequestCallback, this),
+        MakeCallback(&ThreeGppHttpServer::NewConnectionCreatedCallback, this));
+    m_socket->SetCloseCallbacks(MakeCallback(&ThreeGppHttpServer::NormalCloseCallback, this),
+                                MakeCallback(&ThreeGppHttpServer::ErrorCloseCallback, this));
+    m_socket->SetRecvCallback(MakeCallback(&ThreeGppHttpServer::ReceivedDataCallback, this));
+    m_socket->SetSendCallback(MakeCallback(&ThreeGppHttpServer::SendCallback, this));
 
     SwitchToState(STARTED);
 }
 
 void
-ThreeGppHttpServer::StopApplication()
+ThreeGppHttpServer::DoStopApplication()
 {
     NS_LOG_FUNCTION(this);
 
@@ -298,18 +274,6 @@
 
     // Close all accepted sockets.
     m_txBuffer->CloseAllSockets();
-
-    // Stop listening.
-    if (m_initialSocket)
-    {
-        m_initialSocket->Close();
-        m_initialSocket->SetAcceptCallback(MakeNullCallback<bool, Ptr<Socket>, const Address&>(),
-                                           MakeNullCallback<void, Ptr<Socket>, const Address&>());
-        m_initialSocket->SetCloseCallbacks(MakeNullCallback<void, Ptr<Socket>>(),
-                                           MakeNullCallback<void, Ptr<Socket>>());
-        m_initialSocket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-        m_initialSocket->SetSendCallback(MakeNullCallback<void, Ptr<Socket>, uint32_t>());
-    }
 }
 
 bool
@@ -350,7 +314,7 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    if (socket == m_initialSocket)
+    if (socket == m_socket)
     {
         if (m_state == STARTED)
         {
@@ -386,7 +350,7 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    if (socket == m_initialSocket)
+    if (socket == m_socket)
     {
         if (m_state == STARTED)
         {
@@ -436,6 +400,7 @@
         packet->PeekHeader(httpHeader);
 
         // Fire trace sources.
+        m_rxTraceWithoutAddress(packet);
         m_rxTrace(packet, from);
         m_rxTraceWithAddresses(packet, from, m_local);
         m_rxDelayTrace(Simulator::Now() - httpHeader.GetClientTs(), from);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/three-gpp-http-server.h ns-3.47/src/applications/model/three-gpp-http-server.h
--- ns-3.46/src/applications/model/three-gpp-http-server.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/three-gpp-http-server.h	2026-02-16 16:08:49.571229700 -0800
@@ -27,7 +27,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 class ThreeGppHttpVariables;
 class ThreeGppHttpServerTxBuffer;
@@ -143,15 +142,15 @@
     void DoDispose() override;
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void DoStopApplication() override;
     void SetLocal(const Address& addr) override;
     void SetPort(uint32_t port) override;
 
     // SOCKET CALLBACK METHODS
 
     /**
-     * Invoked when #m_initialSocket receives a connection request.
+     * Invoked when #m_socket receives a connection request.
      * @param socket Pointer to the socket where the event originates from.
      * @param address The address of the remote client where the connection
      *                request comes from.
@@ -179,7 +178,7 @@
      */
     void ErrorCloseCallback(Ptr<Socket> socket);
     /**
-     * Invoked when #m_initialSocket receives some packet data. It will check the
+     * Invoked when #m_socket receives some packet data. It will check the
      * packet for ThreeGppHttpHeader. It also fires the `Rx` trace source.
      *
      * Depending on the type of object requested, the method will trigger
@@ -250,9 +249,7 @@
     void SwitchToState(State_t state);
 
     /// The current state of the client application. Begins with NOT_STARTED.
-    State_t m_state;
-    /// The listening socket, for receiving connection requests from clients.
-    Ptr<Socket> m_initialSocket;
+    State_t m_state{NOT_STARTED};
     /// Pointer to the transmission buffer.
     Ptr<ThreeGppHttpServerTxBuffer> m_txBuffer;
 
@@ -280,8 +277,6 @@
     TracedCallback<uint32_t> m_embeddedObjectTrace;
     /// The `Tx` trace source.
     TracedCallback<Ptr<const Packet>> m_txTrace;
-    /// The `Rx` trace source.
-    TracedCallback<Ptr<const Packet>, const Address&> m_rxTrace;
     /// The `Rx` trace source with the local address.
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_rxTraceWithAddresses;
     /// The `RxDelay` trace source.
